<!-- This comment will put IE 6, 7 and 8 in quirks mode -->
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<title>m17n ライブラリ: 表示</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javaScript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css"/>
</head>
<body onload='searchBox.OnSelectItem(0);'>
<!-- 作成： Doxygen 1.6.3 -->
<script type="text/javascript"><!--
var searchBox = new SearchBox("searchBox", "search",false,'検索');
--></script>
<div class="navigation" id="top">
  <div class="tabs">
    <ul>
      <li><a href="index.html"><span>メインページ</span></a></li>
      <li><a href="pages.html"><span>関連ページ</span></a></li>
      <li><a href="modules.html"><span>モジュール</span></a></li>
      <li><a href="annotated.html"><span>データ構造</span></a></li>
      <li><a href="files.html"><span>ファイル</span></a></li>
      <li>
        <div id="MSearchBox" class="MSearchBoxInactive">
        <img id="MSearchSelect" src="search/search.png"
             onmouseover="return searchBox.OnSearchSelectShow()"
             onmouseout="return searchBox.OnSearchSelectHide()"
             alt=""/>
        <input type="text" id="MSearchField" value="検索" accesskey="S"
             onfocus="searchBox.OnSearchFieldFocus(true)" 
             onblur="searchBox.OnSearchFieldFocus(false)" 
             onkeyup="searchBox.OnSearchFieldChange(event)"/>
        <a id="MSearchClose" href="javascript:searchBox.CloseResultsWindow()"><img id="MSearchCloseImg" border="0" src="search/close.png" alt=""/></a>
        </div>
      </li>
    </ul>
  </div>
</div>
<div class="contents">
<h1>表示<br/>
<small>
[<a class="el" href="group__m17nGUI.html">GUI API</a>]</small>
</h1>
<p>M-text をウィンドウに描画する.  
<a href="#_details">[詳細]</a></p>
<table border="0" cellpadding="0" cellspacing="0">
<tr><td colspan="2"><h2>データ構造</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">struct &nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="structMDrawControl.html">MDrawControl</a></td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">テキスト表示制御の型宣言.  <a href="structMDrawControl.html#_details">[詳細]</a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">struct &nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="structMDrawMetric.html">MDrawMetric</a></td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">グリフとテキストの寸法の型宣言.  <a href="structMDrawMetric.html#_details">[詳細]</a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">struct &nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="structMDrawGlyphInfo.html">MDrawGlyphInfo</a></td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">グリフに関する情報の型宣言.  <a href="structMDrawGlyphInfo.html#_details">[詳細]</a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">struct &nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="structMDrawGlyph.html">MDrawGlyph</a></td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">グリフの寸法とフォントに関する情報の型宣言.  <a href="structMDrawGlyph.html#_details">[詳細]</a><br/></td></tr>
<tr><td colspan="2"><h2>型定義</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">typedef void *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__m17nDraw.html#ga7cf712e335916cc72a77aca96cf327fb">MDrawWindow</a></td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">ウィンドウシステムに依存する、ウィンドウの型宣言.  <a href="#ga7cf712e335916cc72a77aca96cf327fb"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">typedef void *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__m17nDraw.html#ga9818c0695d9162a9637fa4e98a1d477d">MDrawRegion</a></td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">ウィンドウシステムに依存する、領域の型宣言.  <a href="#ga9818c0695d9162a9637fa4e98a1d477d"></a><br/></td></tr>
<tr><td colspan="2"><h2>関数</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">int&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__m17nDraw.html#ga02f9efd2c5d1bdd9d7a6ab18475bbd08">mdraw_text</a> (<a class="el" href="group__m17nFrame.html#gabb36d3a69526a891ce7534bda63a2687">MFrame</a> *frame, <a class="el" href="group__m17nDraw.html#ga7cf712e335916cc72a77aca96cf327fb">MDrawWindow</a> win, int x, int y, <a class="el" href="group__m17nMtext.html#gae8bba45315c15c8f79ec4a73ebc52aec">MText</a> *mt, int from, int to)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">ウィンドウに M-text を描画する.  <a href="#ga02f9efd2c5d1bdd9d7a6ab18475bbd08"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">int&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__m17nDraw.html#gab2de737f283237157b9035961f5a4fa6">mdraw_image_text</a> (<a class="el" href="group__m17nFrame.html#gabb36d3a69526a891ce7534bda63a2687">MFrame</a> *frame, <a class="el" href="group__m17nDraw.html#ga7cf712e335916cc72a77aca96cf327fb">MDrawWindow</a> win, int x, int y, <a class="el" href="group__m17nMtext.html#gae8bba45315c15c8f79ec4a73ebc52aec">MText</a> *mt, int from, int to)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">ディスプレイにM-text を画像として描く.  <a href="#gab2de737f283237157b9035961f5a4fa6"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">int&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__m17nDraw.html#ga43ad1fe4a4a8db80a46450dfa250777a">mdraw_text_with_control</a> (<a class="el" href="group__m17nFrame.html#gabb36d3a69526a891ce7534bda63a2687">MFrame</a> *frame, <a class="el" href="group__m17nDraw.html#ga7cf712e335916cc72a77aca96cf327fb">MDrawWindow</a> win, int x, int y, <a class="el" href="group__m17nMtext.html#gae8bba45315c15c8f79ec4a73ebc52aec">MText</a> *mt, int from, int to, <a class="el" href="structMDrawControl.html">MDrawControl</a> *control)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">ディスプレイにM-text を詳細な制御つきで描く.  <a href="#ga43ad1fe4a4a8db80a46450dfa250777a"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">int&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__m17nDraw.html#ga4f5a3138a20bef57e8660975200a4604">mdraw_text_extents</a> (<a class="el" href="group__m17nFrame.html#gabb36d3a69526a891ce7534bda63a2687">MFrame</a> *frame, <a class="el" href="group__m17nMtext.html#gae8bba45315c15c8f79ec4a73ebc52aec">MText</a> *mt, int from, int to, <a class="el" href="structMDrawControl.html">MDrawControl</a> *control, <a class="el" href="structMDrawMetric.html">MDrawMetric</a> *overall_ink_return, <a class="el" href="structMDrawMetric.html">MDrawMetric</a> *overall_logical_return, <a class="el" href="structMDrawMetric.html">MDrawMetric</a> *overall_line_return)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">テキストの幅（ピクセル単位）を計算する.  <a href="#ga4f5a3138a20bef57e8660975200a4604"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">int&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__m17nDraw.html#gae31ef0340c582c208f07f702f816977f">mdraw_text_per_char_extents</a> (<a class="el" href="group__m17nFrame.html#gabb36d3a69526a891ce7534bda63a2687">MFrame</a> *frame, <a class="el" href="group__m17nMtext.html#gae8bba45315c15c8f79ec4a73ebc52aec">MText</a> *mt, int from, int to, <a class="el" href="structMDrawControl.html">MDrawControl</a> *control, <a class="el" href="structMDrawMetric.html">MDrawMetric</a> *ink_array_return, <a class="el" href="structMDrawMetric.html">MDrawMetric</a> *logical_array_return, int array_size, int *num_chars_return, <a class="el" href="structMDrawMetric.html">MDrawMetric</a> *overall_ink_return, <a class="el" href="structMDrawMetric.html">MDrawMetric</a> *overall_logical_return)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">M-text の各文字の表示範囲を計算する.  <a href="#gae31ef0340c582c208f07f702f816977f"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">int&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__m17nDraw.html#ga30321da41dd8785e54627e845a26cf00">mdraw_coordinates_position</a> (<a class="el" href="group__m17nFrame.html#gabb36d3a69526a891ce7534bda63a2687">MFrame</a> *frame, <a class="el" href="group__m17nMtext.html#gae8bba45315c15c8f79ec4a73ebc52aec">MText</a> *mt, int from, int to, int x_offset, int y_offset, <a class="el" href="structMDrawControl.html">MDrawControl</a> *control)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">指定した座標に最も近い文字の文字位置を得る.  <a href="#ga30321da41dd8785e54627e845a26cf00"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">int&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__m17nDraw.html#ga0b79b3b695577bee9c0d41d4947e7a16">mdraw_glyph_info</a> (<a class="el" href="group__m17nFrame.html#gabb36d3a69526a891ce7534bda63a2687">MFrame</a> *frame, <a class="el" href="group__m17nMtext.html#gae8bba45315c15c8f79ec4a73ebc52aec">MText</a> *mt, int from, int pos, <a class="el" href="structMDrawControl.html">MDrawControl</a> *control, <a class="el" href="structMDrawGlyphInfo.html">MDrawGlyphInfo</a> *info)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">グリフに関する情報を計算する.  <a href="#ga0b79b3b695577bee9c0d41d4947e7a16"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">int&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__m17nDraw.html#ga5ad6646874580721d879c82a8a5dbafc">mdraw_glyph_list</a> (<a class="el" href="group__m17nFrame.html#gabb36d3a69526a891ce7534bda63a2687">MFrame</a> *frame, <a class="el" href="group__m17nMtext.html#gae8bba45315c15c8f79ec4a73ebc52aec">MText</a> *mt, int from, int to, <a class="el" href="structMDrawControl.html">MDrawControl</a> *control, <a class="el" href="structMDrawGlyph.html">MDrawGlyph</a> *glyphs, int array_size, int *num_glyphs_return)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">グリフ列に関する情報を計算する.  <a href="#ga5ad6646874580721d879c82a8a5dbafc"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__m17nDraw.html#ga41ee093d2d8b2d6a8c499ac8802871d6">mdraw_text_items</a> (<a class="el" href="group__m17nFrame.html#gabb36d3a69526a891ce7534bda63a2687">MFrame</a> *frame, <a class="el" href="group__m17nDraw.html#ga7cf712e335916cc72a77aca96cf327fb">MDrawWindow</a> win, int x, int y, <a class="el" href="structMDrawTextItem.html">MDrawTextItem</a> *items, int nitems)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">textitem を表示する.  <a href="#ga41ee093d2d8b2d6a8c499ac8802871d6"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">int&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__m17nDraw.html#ga457d91ccebabb26e1d7ab27f616cecb5">mdraw_default_line_break</a> (<a class="el" href="group__m17nMtext.html#gae8bba45315c15c8f79ec4a73ebc52aec">MText</a> *mt, int pos, int from, int to, int line, int y)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">改行位置を計算する.  <a href="#ga457d91ccebabb26e1d7ab27f616cecb5"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__m17nDraw.html#gae05aed269fc5fe20557a297f439a88ea">mdraw_per_char_extents</a> (<a class="el" href="group__m17nFrame.html#gabb36d3a69526a891ce7534bda63a2687">MFrame</a> *frame, <a class="el" href="group__m17nMtext.html#gae8bba45315c15c8f79ec4a73ebc52aec">MText</a> *mt, <a class="el" href="structMDrawMetric.html">MDrawMetric</a> *array_return, <a class="el" href="structMDrawMetric.html">MDrawMetric</a> *overall_return)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">M-text の文字毎の表示範囲情報を得る.  <a href="#gae05aed269fc5fe20557a297f439a88ea"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__m17nDraw.html#ga74e7bee7646b408dbf11b4866afb1098">mdraw_clear_cache</a> (<a class="el" href="group__m17nMtext.html#gae8bba45315c15c8f79ec4a73ebc52aec">MText</a> *mt)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">キャッシュ情報を消す.  <a href="#ga74e7bee7646b408dbf11b4866afb1098"></a><br/></td></tr>
<tr><td colspan="2"><h2>変数</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">int&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__m17nDraw.html#gaae4c0c421e284fc8084998d20e4a40c5">mdraw_line_break_option</a></td></tr>
</table>
<hr/><a name="_details"></a><h2>説明</h2>
<p>M-text をウィンドウに描画する. </p>
<p>m17n-gui API には、M-text を表示するための関数が用意されている。</p>
<p>表示に用いられるフォントは、フォントセットと face のプロパティに基づいて自動的に決定される。また、フォントのサイズや色や下線などの見栄えも face によって決まる。</p>
<p>M-text の描画フォーマットは多様な方法で制御できるので、強力な二次元レイアウト機能が実現できる。 </p>
<hr/><h2>型定義</h2>
<a class="anchor" id="ga7cf712e335916cc72a77aca96cf327fb"></a><!-- doxytag: member="m17n&#45;gui.h::MDrawWindow" ref="ga7cf712e335916cc72a77aca96cf327fb" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">typedef void* <a class="el" href="group__m17nDraw.html#ga7cf712e335916cc72a77aca96cf327fb">MDrawWindow</a></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>ウィンドウシステムに依存する、ウィンドウの型宣言. </p>
<p><a class="el" href="group__m17nDraw.html#ga7cf712e335916cc72a77aca96cf327fb" title="ウィンドウシステムに依存する、ウィンドウの型宣言.">MDrawWindow</a> はウィンドウ、すなわち幾つかの点でスクリーンのミニチュアとして働く矩形領域用の型である。</p>
<p>実際に何を指すかはウィンドウシステムに依存する。 m17n X ライブラリを利用するプログラムは <code>Drawable</code> 型をこの型に変換しなくてはならない。 </p>

</div>
</div>
<a class="anchor" id="ga9818c0695d9162a9637fa4e98a1d477d"></a><!-- doxytag: member="m17n&#45;gui.h::MDrawRegion" ref="ga9818c0695d9162a9637fa4e98a1d477d" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">typedef void* <a class="el" href="group__m17nDraw.html#ga9818c0695d9162a9637fa4e98a1d477d">MDrawRegion</a></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>ウィンドウシステムに依存する、領域の型宣言. </p>
<p><a class="el" href="group__m17nDraw.html#ga9818c0695d9162a9637fa4e98a1d477d" title="ウィンドウシステムに依存する、領域の型宣言.">MDrawRegion</a> は領域、すなわちスクリーン上の任意のピクセルの集合（典型的には矩形領域）用の型である。</p>
<p>実際に何を指すかはウィンドウシステムに依存する。 m17n X ライブラリを利用するプログラムは <code>Region</code> 型をこの型に変換しなくてはならない。 </p>

</div>
</div>
<hr/><h2>関数</h2>
<a class="anchor" id="ga02f9efd2c5d1bdd9d7a6ab18475bbd08"></a><!-- doxytag: member="draw.c::mdraw_text" ref="ga02f9efd2c5d1bdd9d7a6ab18475bbd08" args="(MFrame *frame, MDrawWindow win, int x, int y, MText *mt, int from, int to)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int mdraw_text </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="group__m17nFrame.html#gabb36d3a69526a891ce7534bda63a2687">MFrame</a> *&nbsp;</td>
          <td class="paramname"> <em>frame</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="group__m17nDraw.html#ga7cf712e335916cc72a77aca96cf327fb">MDrawWindow</a>&nbsp;</td>
          <td class="paramname"> <em>win</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&nbsp;</td>
          <td class="paramname"> <em>x</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&nbsp;</td>
          <td class="paramname"> <em>y</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="group__m17nMtext.html#gae8bba45315c15c8f79ec4a73ebc52aec">MText</a> *&nbsp;</td>
          <td class="paramname"> <em>mt</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&nbsp;</td>
          <td class="paramname"> <em>from</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&nbsp;</td>
          <td class="paramname"> <em>to</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>ウィンドウに M-text を描画する. </p>
<p>関数 <a class="el" href="group__m17nDraw.html#ga02f9efd2c5d1bdd9d7a6ab18475bbd08" title="ウィンドウに M-text を描画する.">mdraw_text()</a> は、フレーム <b>frame</b> のウィンドウ <b>win</b> の座標 (<b>x</b>, <b>y</b>) に、M-text <b>mt</b> の <b>from</b> から <b>to</b> までのテキストを描画する。</p>
<p>テキストの見栄え（フォント、スタイル、色など）は、キーが <code>Mface</code> であるテキストプロパティの値によって決まる。M-text の一部あるいは全部にそのようなテキストプロパティが付いていない場合には、<b>frame</b> のデフォルトフェースを代わりに用いる。</p>
<p>M-text の各文字を表示するフォントは、フェースの fontset プロパティの値のうちから、以下のアルゴリズムで選ばれる。</p>
<ol>
<li>
<p class="startli">その文字のテキストプロパティのうち、キーが <code>Mcharset</code> であるものの値を調べる。この値は文字セットを表わすシンボルか <a class="el" href="group__m17nSymbol.html#ga0346fc05efcccc8f11271b51c0fe3eeb" title="&quot;nil&quot; を名前として持つシンボル.">Mnil</a> のどちらかである。<a class="el" href="group__m17nSymbol.html#ga0346fc05efcccc8f11271b51c0fe3eeb" title="&quot;nil&quot; を名前として持つシンボル.">Mnil</a> ならば、次のステップに進む。 そうでなければ、fontset のマッピングテーブルにその文字セット用のフォントがあるかどうかを調べる。 無ければ、次のステップに進む。</p>
<p>その文字セット用のフォントがみつかれば、それらのうち現在の文字用のグリフを持ち、フェースの各プロパティに最もよく合致するものを使う。 そのようなフォントが無ければ次のステップに進む。</p>
<p class="endli"></p>
</li>
<li>
<p class="startli">その文字の文字プロパティ "script" （スクリプト）を調べる。 そのプロパティが継承されているならばそれ以前の文字の文字プロパティ "script" を調べる。前の文字がなかったり、その文字プロパティを持っていなかった場合には、次のステップに進む。</p>
<p>その文字のテキストプロパティのうち、キーが <code>Mlanguage</code> であるものの値を調べる。 この値は言語を表わすシンボルか <code>Mnil</code> のいずれかである。</p>
<p>その言語とスクリプトの組み合わせが fontset のマッピングテーブルにあるかどうかを調べる。見つからなければ次のステップに進む。</p>
<p>見つかったばあいには、それらのフォントのうち現在の文字用のグリフを持ち、フェースの各プロパティに最もよく合致しているものを使う。 そのようなフォントが無ければ次のステップに進む。</p>
<p class="endli"></p>
</li>
<li>
<p class="startli">その文字のグリフを持つフォントを、フォントセットの fall-back テーブルから探す。フォントが見つかればそれを使う。</p>
<p class="endli"></p>
</li>
</ol>
<p>以上のアルゴリズムでフォントが見つからなければ、この関数はその文字として空の四角形を表示する。</p>
<p>この関数が描画するのはグリフの前景だけである。背景色を指定するには、関数 <a class="el" href="group__m17nDraw.html#gab2de737f283237157b9035961f5a4fa6" title="ディスプレイにM-text を画像として描く.">mdraw_image_text()</a> か関数 <a class="el" href="group__m17nDraw.html#ga43ad1fe4a4a8db80a46450dfa250777a" title="ディスプレイにM-text を詳細な制御つきで描く.">mdraw_text_with_control()</a> を使うこと。</p>
<p>この関数は、X ウィンドウにおける関数 <code>XDrawString()</code>, <code>XmbDrawString()</code>, <code>XwcDrawString()</code> に相当する。</p>
<dl class="user"><dt><b>戻り値:</b></dt><dd>処理が成功した場合、mdraw_text() は 0 返す。エラーが検出された場合は -1 を返し、外部変数 <a class="el" href="group__m17nError.html#ga995a2e373cfd6a8e5eaca8686b5b0a73" title="m17n ライブラリのエラーコードを保持する外部変数.">merror_code</a> にエラーコードを設定する。</dd></dl>
<dl class="user"><dt><b>エラー:</b></dt><dd><code>MERROR_RANGE</code> </dd></dl>
<dl class="user"><dt><b>参照:</b></dt><dd><a class="el" href="group__m17nDraw.html#gab2de737f283237157b9035961f5a4fa6" title="ディスプレイにM-text を画像として描く.">mdraw_image_text()</a> </dd></dl>

</div>
</div>
<a class="anchor" id="gab2de737f283237157b9035961f5a4fa6"></a><!-- doxytag: member="draw.c::mdraw_image_text" ref="gab2de737f283237157b9035961f5a4fa6" args="(MFrame *frame, MDrawWindow win, int x, int y, MText *mt, int from, int to)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int mdraw_image_text </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="group__m17nFrame.html#gabb36d3a69526a891ce7534bda63a2687">MFrame</a> *&nbsp;</td>
          <td class="paramname"> <em>frame</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="group__m17nDraw.html#ga7cf712e335916cc72a77aca96cf327fb">MDrawWindow</a>&nbsp;</td>
          <td class="paramname"> <em>win</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&nbsp;</td>
          <td class="paramname"> <em>x</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&nbsp;</td>
          <td class="paramname"> <em>y</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="group__m17nMtext.html#gae8bba45315c15c8f79ec4a73ebc52aec">MText</a> *&nbsp;</td>
          <td class="paramname"> <em>mt</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&nbsp;</td>
          <td class="paramname"> <em>from</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&nbsp;</td>
          <td class="paramname"> <em>to</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>ディスプレイにM-text を画像として描く. </p>
<p>関数 <a class="el" href="group__m17nDraw.html#gab2de737f283237157b9035961f5a4fa6" title="ディスプレイにM-text を画像として描く.">mdraw_image_text()</a> は、フレーム <b>frame</b> のウィンドウ <b>win</b> の座標 (<b>x</b>, <b>y</b>) に、M-text <b>mt</b> の <b>from</b> から <b>to</b> までのテキストを画像として描く。</p>
<p>テキストの描画方法は <a class="el" href="group__m17nDraw.html#ga02f9efd2c5d1bdd9d7a6ab18475bbd08" title="ウィンドウに M-text を描画する.">mdraw_text()</a> とほぼ同じであるが、この関数ではフェースで指定された色で背景も描く点が異なっている。</p>
<p>この関数は、X ウィンドウにおける <code>XDrawImageString()</code>, <code>XmbDrawImageString()</code>, <code>XwcDrawImageString()</code> に相当する。</p>
<dl class="user"><dt><b>戻り値:</b></dt><dd>処理が成功した場合、mdraw_image_text() は 0 を返す。エラーが検出された場合は -1 を返し、外部変数 <a class="el" href="group__m17nError.html#ga995a2e373cfd6a8e5eaca8686b5b0a73" title="m17n ライブラリのエラーコードを保持する外部変数.">merror_code</a> にエラーコードを設定する。</dd></dl>
<dl class="user"><dt><b>エラー:</b></dt><dd><code>MERROR_RANGE</code> </dd></dl>
<dl class="user"><dt><b>参照:</b></dt><dd><a class="el" href="group__m17nDraw.html#ga02f9efd2c5d1bdd9d7a6ab18475bbd08" title="ウィンドウに M-text を描画する.">mdraw_text()</a> </dd></dl>

</div>
</div>
<a class="anchor" id="ga43ad1fe4a4a8db80a46450dfa250777a"></a><!-- doxytag: member="draw.c::mdraw_text_with_control" ref="ga43ad1fe4a4a8db80a46450dfa250777a" args="(MFrame *frame, MDrawWindow win, int x, int y, MText *mt, int from, int to, MDrawControl *control)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int mdraw_text_with_control </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="group__m17nFrame.html#gabb36d3a69526a891ce7534bda63a2687">MFrame</a> *&nbsp;</td>
          <td class="paramname"> <em>frame</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="group__m17nDraw.html#ga7cf712e335916cc72a77aca96cf327fb">MDrawWindow</a>&nbsp;</td>
          <td class="paramname"> <em>win</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&nbsp;</td>
          <td class="paramname"> <em>x</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&nbsp;</td>
          <td class="paramname"> <em>y</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="group__m17nMtext.html#gae8bba45315c15c8f79ec4a73ebc52aec">MText</a> *&nbsp;</td>
          <td class="paramname"> <em>mt</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&nbsp;</td>
          <td class="paramname"> <em>from</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&nbsp;</td>
          <td class="paramname"> <em>to</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="structMDrawControl.html">MDrawControl</a> *&nbsp;</td>
          <td class="paramname"> <em>control</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>ディスプレイにM-text を詳細な制御つきで描く. </p>
<p>関数 <a class="el" href="group__m17nDraw.html#ga43ad1fe4a4a8db80a46450dfa250777a" title="ディスプレイにM-text を詳細な制御つきで描く.">mdraw_text_with_control()</a> は、フレーム <b>frame</b> のウィンドウ <b>win</b> の座標 (<b>x</b>, <b>y</b>) に、M-text <b>mt</b> の <b>from</b> から <b>to</b> までのテキス トを描く。</p>
<p>テキストの描画方法は <a class="el" href="group__m17nDraw.html#ga02f9efd2c5d1bdd9d7a6ab18475bbd08" title="ウィンドウに M-text を描画する.">mdraw_text()</a> とほぼ同じであるが、この関数は描画制御用のオブジェクト <b>control</b> の指示にも従う点が異なっている。</p>
<p>たとえば <b>control</b> の &lt;two_dimensional&gt; がゼロでなければ、この関数は M-text を2次元的に描く。すなわち M-text 中の改行で行を改め、続く文字は次の行に描く。詳細は構造体 @ <a class="el" href="structMDrawControl.html" title="テキスト表示制御の型宣言.">MDrawControl</a> の説明を参照すること。 </p>

</div>
</div>
<a class="anchor" id="ga4f5a3138a20bef57e8660975200a4604"></a><!-- doxytag: member="draw.c::mdraw_text_extents" ref="ga4f5a3138a20bef57e8660975200a4604" args="(MFrame *frame, MText *mt, int from, int to, MDrawControl *control, MDrawMetric *overall_ink_return, MDrawMetric *overall_logical_return, MDrawMetric *overall_line_return)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int mdraw_text_extents </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="group__m17nFrame.html#gabb36d3a69526a891ce7534bda63a2687">MFrame</a> *&nbsp;</td>
          <td class="paramname"> <em>frame</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="group__m17nMtext.html#gae8bba45315c15c8f79ec4a73ebc52aec">MText</a> *&nbsp;</td>
          <td class="paramname"> <em>mt</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&nbsp;</td>
          <td class="paramname"> <em>from</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&nbsp;</td>
          <td class="paramname"> <em>to</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="structMDrawControl.html">MDrawControl</a> *&nbsp;</td>
          <td class="paramname"> <em>control</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="structMDrawMetric.html">MDrawMetric</a> *&nbsp;</td>
          <td class="paramname"> <em>overall_ink_return</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="structMDrawMetric.html">MDrawMetric</a> *&nbsp;</td>
          <td class="paramname"> <em>overall_logical_return</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="structMDrawMetric.html">MDrawMetric</a> *&nbsp;</td>
          <td class="paramname"> <em>overall_line_return</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>テキストの幅（ピクセル単位）を計算する. </p>
<p>関数 <a class="el" href="group__m17nDraw.html#ga4f5a3138a20bef57e8660975200a4604" title="テキストの幅（ピクセル単位）を計算する.">mdraw_text_extents()</a> は、関数 <a class="el" href="group__m17nDraw.html#ga43ad1fe4a4a8db80a46450dfa250777a" title="ディスプレイにM-text を詳細な制御つきで描く.">mdraw_text_with_control()</a> が描画制御オブジェクト <b>control</b> を用いて M-text <b>mt</b> の <b>from</b> から <b>to</b> までをフレーム <b>frame</b> に表示する際に必要となる幅を返す。</p>
<p><b>overall_ink_return</b> が <code>NULL</code> でなければ、この関数は M-text の文字のインクのバウンディングボックスも計算し、<b>overall_ink_return</b> が指す構造体のメンバにその結果を設定する。M-text に囲み枠 (surrounding box) を指定するフェースがあれば、それもバウンディングボックスに含む。</p>
<p><b>overall_logical_return</b> が <code>NULL</code> でなければ、この関数は M-text と他の graphical feature （囲み枠など） との間の最小のスペースを示すバウンディングボックスも計算し、<b>overall_logical_return</b> が指す構造体のメンバにその結果を設定する。</p>
<p><b>overall_line_return</b> が <code>NULL</code> でなければ、この関数は他の M-text との間の最小のスペースを示すバウンディングボックスも計算し、 <b>overall_line_return</b> が指す構造体のメンバにその結果を設定する。オブジェクト <b>control</b> のメンバ min_line_ascent, min_line_descent, max_line_ascent, max_line_descent がすべて0の時には、この値は <b>overall_ink_return</b> と<b>overall_logical_return</b> の和となる。</p>
<dl class="user"><dt><b>戻り値: </b></dt><dd>この関数は表示に必要なテキストの幅をピクセル単位で返す。<b>control-&gt;two_dimensional</b> が0でなく、テキストが複数の行に渡って描かれる場合には、最大の幅を返す。エラーが生じた場合は -1 を返し、外部変数 <a class="el" href="group__m17nError.html#ga995a2e373cfd6a8e5eaca8686b5b0a73" title="m17n ライブラリのエラーコードを保持する外部変数.">merror_code</a> にエラーコードを設定する。</dd></dl>
<dl class="user"><dt><b>エラー:</b></dt><dd><code>MERROR_RANGE</code> </dd></dl>

</div>
</div>
<a class="anchor" id="gae31ef0340c582c208f07f702f816977f"></a><!-- doxytag: member="draw.c::mdraw_text_per_char_extents" ref="gae31ef0340c582c208f07f702f816977f" args="(MFrame *frame, MText *mt, int from, int to, MDrawControl *control, MDrawMetric *ink_array_return, MDrawMetric *logical_array_return, int array_size, int *num_chars_return, MDrawMetric *overall_ink_return, MDrawMetric *overall_logical_return)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int mdraw_text_per_char_extents </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="group__m17nFrame.html#gabb36d3a69526a891ce7534bda63a2687">MFrame</a> *&nbsp;</td>
          <td class="paramname"> <em>frame</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="group__m17nMtext.html#gae8bba45315c15c8f79ec4a73ebc52aec">MText</a> *&nbsp;</td>
          <td class="paramname"> <em>mt</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&nbsp;</td>
          <td class="paramname"> <em>from</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&nbsp;</td>
          <td class="paramname"> <em>to</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="structMDrawControl.html">MDrawControl</a> *&nbsp;</td>
          <td class="paramname"> <em>control</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="structMDrawMetric.html">MDrawMetric</a> *&nbsp;</td>
          <td class="paramname"> <em>ink_array_return</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="structMDrawMetric.html">MDrawMetric</a> *&nbsp;</td>
          <td class="paramname"> <em>logical_array_return</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&nbsp;</td>
          <td class="paramname"> <em>array_size</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int *&nbsp;</td>
          <td class="paramname"> <em>num_chars_return</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="structMDrawMetric.html">MDrawMetric</a> *&nbsp;</td>
          <td class="paramname"> <em>overall_ink_return</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="structMDrawMetric.html">MDrawMetric</a> *&nbsp;</td>
          <td class="paramname"> <em>overall_logical_return</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>M-text の各文字の表示範囲を計算する. </p>
<p>関数 <a class="el" href="group__m17nDraw.html#gae31ef0340c582c208f07f702f816977f" title="M-text の各文字の表示範囲を計算する.">mdraw_text_per_char_extents()</a> は、関数 <a class="el" href="group__m17nDraw.html#ga43ad1fe4a4a8db80a46450dfa250777a" title="ディスプレイにM-text を詳細な制御つきで描く.">mdraw_text_with_control()</a> が描画制御オブジェクト <b>control</b> を用いて M-text <b>mt</b> の <b>from</b> から <b>to</b> までをフレーム <b>frame</b> に表示する際の各文字のサイズを計算する。</p>
<p><b>array_size</b> によって <b>ink_array_return</b> と<b>logical_array_return</b> のサイズを指定する。<b>ink_array_return</b> と<b>logical_array_return</b> の各要素は、それぞれ文字の描画インクと論理サイズ（M-text の表示原点からの相対位値）によって順に埋められる。設定された <b>ink_array_return</b> と <b>logical_array_return</b> の要素の数は、<b>num_chars_return</b> に戻される。</p>
<p><b>array_size</b> がすべての寸法を戻せないほど小さい場合には、関数は -1 を返し、必要な大きさを <b>num_chars_return</b> に返す。そうでなければ 0 を返す。</p>
<p>ポインタ <b>overall_ink_return</b> と <b>overall_logical_return</b> が<code>NULL</code> でなければ、この関数はテキスト全体のサイズも計算し、結果を <b>overall_ink_return</b> と <b>overall_logical_return</b> で指される構造のメンバに保存する。</p>
<p><b>control-&gt;two_dimensional</b> が0でなければ、この関数は最初の行の文字のサイズだけを計算する。 </p>

</div>
</div>
<a class="anchor" id="ga30321da41dd8785e54627e845a26cf00"></a><!-- doxytag: member="draw.c::mdraw_coordinates_position" ref="ga30321da41dd8785e54627e845a26cf00" args="(MFrame *frame, MText *mt, int from, int to, int x_offset, int y_offset, MDrawControl *control)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int mdraw_coordinates_position </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="group__m17nFrame.html#gabb36d3a69526a891ce7534bda63a2687">MFrame</a> *&nbsp;</td>
          <td class="paramname"> <em>frame</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="group__m17nMtext.html#gae8bba45315c15c8f79ec4a73ebc52aec">MText</a> *&nbsp;</td>
          <td class="paramname"> <em>mt</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&nbsp;</td>
          <td class="paramname"> <em>from</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&nbsp;</td>
          <td class="paramname"> <em>to</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&nbsp;</td>
          <td class="paramname"> <em>x_offset</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&nbsp;</td>
          <td class="paramname"> <em>y_offset</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="structMDrawControl.html">MDrawControl</a> *&nbsp;</td>
          <td class="paramname"> <em>control</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>指定した座標に最も近い文字の文字位置を得る. </p>
<p>関数 <a class="el" href="group__m17nDraw.html#ga30321da41dd8785e54627e845a26cf00" title="指定した座標に最も近い文字の文字位置を得る.">mdraw_coordinates_position()</a> は、関数 <a class="el" href="group__m17nDraw.html#ga43ad1fe4a4a8db80a46450dfa250777a" title="ディスプレイにM-text を詳細な制御つきで描く.">mdraw_text_with_control()</a> が描画制御オブジェクト <b>control</b> を用いて、 M-text <b>mt</b> の <b>from</b> から <b>to</b> までを座標 (0, 0) を起点として描画する際に、座標 (<b>x</b>, <b>y</b>) に描画される文字の文字位置を返す。ここで文字位置とは、当該 M-text 中においてその文字が最初から何番目かを示す整数である。ただし最初の文字の文字位置は0とする。</p>
<p><b>frame</b> はデフォルトのフェースの情報を得るためだけに用いられる。</p>
<dl class="user"><dt><b>戻り値:</b></dt><dd>座標 (<b>x</b>, <b>y</b>) がある文字のグリフで覆われる場合、 関数 <a class="el" href="group__m17nDraw.html#ga30321da41dd8785e54627e845a26cf00" title="指定した座標に最も近い文字の文字位置を得る.">mdraw_coordinates_position()</a> はその文字の文字位置を返す。<br/>
<br/>
 もし <b>y</b> が描画領域の最小Y座標よりも小さいならば <b>from</b> を返す。<br/>
<br/>
 もし <b>y</b> が描画領域の最大Y座標よりも大きいならば <b>to</b> を返す。<br/>
<br/>
 もし <b>y</b> が描画領域に乗っていてかつ <b>x</b> が描画領域の最小X座標よりも 小さい場合は、直線 y = <b>y</b> 上に描画される最初の文字の文字位置を返す。<br/>
<br/>
 もし <b>y</b> が描画領域に乗っていてかつ <b>x</b> が描画領域の最大X座標よりも 大きい場合は、直線 y = <b>y</b> 上に描画される最後の文字の文字位置を返す。 </dd></dl>

</div>
</div>
<a class="anchor" id="ga0b79b3b695577bee9c0d41d4947e7a16"></a><!-- doxytag: member="draw.c::mdraw_glyph_info" ref="ga0b79b3b695577bee9c0d41d4947e7a16" args="(MFrame *frame, MText *mt, int from, int pos, MDrawControl *control, MDrawGlyphInfo *info)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int mdraw_glyph_info </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="group__m17nFrame.html#gabb36d3a69526a891ce7534bda63a2687">MFrame</a> *&nbsp;</td>
          <td class="paramname"> <em>frame</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="group__m17nMtext.html#gae8bba45315c15c8f79ec4a73ebc52aec">MText</a> *&nbsp;</td>
          <td class="paramname"> <em>mt</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&nbsp;</td>
          <td class="paramname"> <em>from</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&nbsp;</td>
          <td class="paramname"> <em>pos</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="structMDrawControl.html">MDrawControl</a> *&nbsp;</td>
          <td class="paramname"> <em>control</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="structMDrawGlyphInfo.html">MDrawGlyphInfo</a> *&nbsp;</td>
          <td class="paramname"> <em>info</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>グリフに関する情報を計算する. </p>
<p>関数 <a class="el" href="group__m17nDraw.html#ga0b79b3b695577bee9c0d41d4947e7a16" title="グリフに関する情報を計算する.">mdraw_glyph_info()</a> は、関数 <a class="el" href="group__m17nDraw.html#ga43ad1fe4a4a8db80a46450dfa250777a" title="ディスプレイにM-text を詳細な制御つきで描く.">mdraw_text_with_control()</a> が描 画制御オブジェクト <b>control</b> を用いてM-text <b>mt</b> の <b>from</b> から <b>to</b> までをフレーム <b>frame</b> に描画した場合、M-text の文字位置 <b>pos</b> の文字を覆うグリフに関する情報を計算する。</p>
<p>情報は<b>info</b> のメンバに保持される。</p>
<dl class="user"><dt><b>参照:</b></dt><dd><a class="el" href="structMDrawGlyphInfo.html" title="グリフに関する情報の型宣言.">MDrawGlyphInfo</a> </dd></dl>

</div>
</div>
<a class="anchor" id="ga5ad6646874580721d879c82a8a5dbafc"></a><!-- doxytag: member="draw.c::mdraw_glyph_list" ref="ga5ad6646874580721d879c82a8a5dbafc" args="(MFrame *frame, MText *mt, int from, int to, MDrawControl *control, MDrawGlyph *glyphs, int array_size, int *num_glyphs_return)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int mdraw_glyph_list </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="group__m17nFrame.html#gabb36d3a69526a891ce7534bda63a2687">MFrame</a> *&nbsp;</td>
          <td class="paramname"> <em>frame</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="group__m17nMtext.html#gae8bba45315c15c8f79ec4a73ebc52aec">MText</a> *&nbsp;</td>
          <td class="paramname"> <em>mt</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&nbsp;</td>
          <td class="paramname"> <em>from</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&nbsp;</td>
          <td class="paramname"> <em>to</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="structMDrawControl.html">MDrawControl</a> *&nbsp;</td>
          <td class="paramname"> <em>control</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="structMDrawGlyph.html">MDrawGlyph</a> *&nbsp;</td>
          <td class="paramname"> <em>glyphs</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&nbsp;</td>
          <td class="paramname"> <em>array_size</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int *&nbsp;</td>
          <td class="paramname"> <em>num_glyphs_return</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>グリフ列に関する情報を計算する. </p>
<p>関数 <a class="el" href="group__m17nDraw.html#ga5ad6646874580721d879c82a8a5dbafc" title="グリフ列に関する情報を計算する.">mdraw_glyph_list()</a> は、関数 <a class="el" href="group__m17nDraw.html#ga43ad1fe4a4a8db80a46450dfa250777a" title="ディスプレイにM-text を詳細な制御つきで描く.">mdraw_text_with_control()</a> が描画制御オブジェクト <b>control</b> を用いてM-text <b>mt</b> の <b>from</b> から <b>to</b> までをフレーム <b>frame</b> に描画した場合の、各グリフの情報を <b>glyphs</b> が指す配列に格納する。 <b>array_size</b> はその配列のサイズである。</p>
<p>もし <b>array_size</b> がすべてのグリフについての情報を格納するのに十分であれば、 <b>num_glyphs_return</b> が指す場所に実際に埋めた要素の数を設定し 0 を返す。</p>
<p>そうでなければ、<b>num_glyphs_return</b> が指す場所に必要な配列のサイズを設定し、 -1 を返す。</p>
<dl class="user"><dt><b>参照:</b></dt><dd><a class="el" href="structMDrawGlyph.html" title="グリフの寸法とフォントに関する情報の型宣言.">MDrawGlyph</a> </dd></dl>

</div>
</div>
<a class="anchor" id="ga41ee093d2d8b2d6a8c499ac8802871d6"></a><!-- doxytag: member="draw.c::mdraw_text_items" ref="ga41ee093d2d8b2d6a8c499ac8802871d6" args="(MFrame *frame, MDrawWindow win, int x, int y, MDrawTextItem *items, int nitems)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void mdraw_text_items </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="group__m17nFrame.html#gabb36d3a69526a891ce7534bda63a2687">MFrame</a> *&nbsp;</td>
          <td class="paramname"> <em>frame</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="group__m17nDraw.html#ga7cf712e335916cc72a77aca96cf327fb">MDrawWindow</a>&nbsp;</td>
          <td class="paramname"> <em>win</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&nbsp;</td>
          <td class="paramname"> <em>x</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&nbsp;</td>
          <td class="paramname"> <em>y</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="structMDrawTextItem.html">MDrawTextItem</a> *&nbsp;</td>
          <td class="paramname"> <em>items</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&nbsp;</td>
          <td class="paramname"> <em>nitems</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>textitem を表示する. </p>
<p>関数 <a class="el" href="group__m17nDraw.html#ga41ee093d2d8b2d6a8c499ac8802871d6" title="textitem を表示する.">mdraw_text_items()</a> は、一個以上のテキストアイテムを、フレーム <b>frame</b> のウィンドウ <b>win</b> の座標 (<b>x</b>, <b>y</b>) に表示する。<b>items</b> は表示すべきテキストアイテムの配列であり、<b>nitems</b> はその個数である。</p>
<dl class="user"><dt><b>参照:</b></dt><dd>MTextItem, <a class="el" href="group__m17nDraw.html#ga02f9efd2c5d1bdd9d7a6ab18475bbd08" title="ウィンドウに M-text を描画する.">mdraw_text()</a>. </dd></dl>

</div>
</div>
<a class="anchor" id="ga457d91ccebabb26e1d7ab27f616cecb5"></a><!-- doxytag: member="draw.c::mdraw_default_line_break" ref="ga457d91ccebabb26e1d7ab27f616cecb5" args="(MText *mt, int pos, int from, int to, int line, int y)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int mdraw_default_line_break </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="group__m17nMtext.html#gae8bba45315c15c8f79ec4a73ebc52aec">MText</a> *&nbsp;</td>
          <td class="paramname"> <em>mt</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&nbsp;</td>
          <td class="paramname"> <em>pos</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&nbsp;</td>
          <td class="paramname"> <em>from</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&nbsp;</td>
          <td class="paramname"> <em>to</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&nbsp;</td>
          <td class="paramname"> <em>line</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&nbsp;</td>
          <td class="paramname"> <em>y</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>改行位置を計算する. </p>
<p>関数 <a class="el" href="group__m17nDraw.html#ga457d91ccebabb26e1d7ab27f616cecb5" title="改行位置を計算する.">mdraw_default_line_break()</a> は、行が最大幅中に収まらない場合の改行位置を、行番号 <b>line</b> と座標 <b>y</b> に基づいて計算する。 <b>pos</b> は最大幅に収まる最後の文字の次の文字の位置である。 <b>from</b> はその行の最初の文字の位置、<b>to</b> は最大幅が指定されていなければその行に表示される最後の文字の位置である。 <b>line</b> と <b>y</b> は改行文字によって行が改まった際には 0 にリセットされ、最大幅によって行が改まった場合には 1 づつ増やされる。</p>
<dl class="user"><dt><b>戻り値: </b></dt><dd>この関数は改行する文字位置を返す。 </dd></dl>

</div>
</div>
<a class="anchor" id="gae05aed269fc5fe20557a297f439a88ea"></a><!-- doxytag: member="draw.c::mdraw_per_char_extents" ref="gae05aed269fc5fe20557a297f439a88ea" args="(MFrame *frame, MText *mt, MDrawMetric *array_return, MDrawMetric *overall_return)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void mdraw_per_char_extents </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="group__m17nFrame.html#gabb36d3a69526a891ce7534bda63a2687">MFrame</a> *&nbsp;</td>
          <td class="paramname"> <em>frame</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="group__m17nMtext.html#gae8bba45315c15c8f79ec4a73ebc52aec">MText</a> *&nbsp;</td>
          <td class="paramname"> <em>mt</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="structMDrawMetric.html">MDrawMetric</a> *&nbsp;</td>
          <td class="paramname"> <em>array_return</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="structMDrawMetric.html">MDrawMetric</a> *&nbsp;</td>
          <td class="paramname"> <em>overall_return</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>M-text の文字毎の表示範囲情報を得る. </p>
<p>関数 <a class="el" href="group__m17nDraw.html#gae05aed269fc5fe20557a297f439a88ea" title="M-text の文字毎の表示範囲情報を得る.">mdraw_per_char_extents()</a> は、M-text <b>mt</b> 中の各文字の表示範囲を計算する。この計算に用いるフォントは、 <b>mt</b> のテキストプロパティで指定されたフェースと、フレーム <b>frame</b> のデフォルトフェースによって決まる。<b>array_return</b> の各要素は、<b>mt</b> 中の各文字の表示範囲情報によって順に埋められる。表示範囲情報とは、 表示原点からの相対位置と各文字の占める長方形である。<b>array_return</b> の要素数は、M-text 中の文字数以上でなければならない。</p>
<p>ポインタ <b>overall_return</b> が <code>NULL</code> でない場合は、テキスト全体の表示範囲情報も計算し、その結果を <b>overall_return</b> の指す構造体に格納する。</p>
 
</div>
</div>
<a class="anchor" id="ga74e7bee7646b408dbf11b4866afb1098"></a><!-- doxytag: member="draw.c::mdraw_clear_cache" ref="ga74e7bee7646b408dbf11b4866afb1098" args="(MText *mt)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void mdraw_clear_cache </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="group__m17nMtext.html#gae8bba45315c15c8f79ec4a73ebc52aec">MText</a> *&nbsp;</td>
          <td class="paramname"> <em>mt</em></td>
          <td>&nbsp;)&nbsp;</td>
          <td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>キャッシュ情報を消す. </p>
<p>関数 <a class="el" href="group__m17nDraw.html#ga74e7bee7646b408dbf11b4866afb1098" title="キャッシュ情報を消す.">mdraw_clear_cache()</a> は描画関数によって M-text <b>mt</b> に付加されたキャッシュ情報をすべて消去する。MDrawControl の `format' あるいは `line_break' メンバ関数の振舞いが変わった場合にはキャッシュを消去しなくてはならない。</p>
<dl class="user"><dt><b>参照:</b></dt><dd><a class="el" href="structMDrawControl.html" title="テキスト表示制御の型宣言.">MDrawControl</a> </dd></dl>

</div>
</div>
<hr/><h2>変数</h2>
<a class="anchor" id="gaae4c0c421e284fc8084998d20e4a40c5"></a><!-- doxytag: member="draw.c::mdraw_line_break_option" ref="gaae4c0c421e284fc8084998d20e4a40c5" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int <a class="el" href="group__m17nDraw.html#gaae4c0c421e284fc8084998d20e4a40c5">mdraw_line_break_option</a></td>
        </tr>
      </table>
</div>
<div class="memdoc">

</div>
</div>
</div>
<!--- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
<a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(0)"><span class="SelectionMark">&nbsp;</span>全て</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(1)"><span class="SelectionMark">&nbsp;</span>データ構造</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(2)"><span class="SelectionMark">&nbsp;</span>ファイル</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(3)"><span class="SelectionMark">&nbsp;</span>関数</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(4)"><span class="SelectionMark">&nbsp;</span>変数</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(5)"><span class="SelectionMark">&nbsp;</span>型定義</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(6)"><span class="SelectionMark">&nbsp;</span>列挙型</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(7)"><span class="SelectionMark">&nbsp;</span>列挙型の値</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(8)"><span class="SelectionMark">&nbsp;</span>マクロ定義</a></div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<!-- -*- coding: utf-8; -*- -->
<hr>

<ADDRESS>
<a href="http://www.m17n.org/m17n-lib-ja/index.html" target="mulewindow"><img src="parrot.png" align=bottom alt="m17n-lib Home" border=0></a>
</ADDRESS>
</body>
</HTML>

<!-- Copyright information

Copyright (C) 2001 Information-technology Promotion Agency (IPA)
Copyright (C) 2001-2011
  National Institute of Advanced Industrial Science and Technology (AIST)

This file is part of the m17n library documentation.

Permission is granted to copy, distribute and/or modify this document
under the terms of the GNU Free Documentation License, Version 1.2 or
any later version published by the Free Software Foundation; with no
Invariant Section, no Front-Cover Texts,
and no Back-Cover Texts.  A copy of the license is included in the
appendix entitled "GNU Free Documentation License".
-->
